#include <iostream>
#include <vector>
#include <map>

using namespace std;

const int INF = 2e9;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

map<string,vector<int> >mp;

int convert(string &st){
    string s;
    while(!st.empty() && st.back() != '-'){
        s += st.back();
        st.pop_back();
    }
    int ans = 0;
    while(!s.empty()){
        ans *= 10;
        ans += s.back()-'0';
        s.pop_back();
    }
    if(!st.empty())
        ans *= -1;
    return ans;
}

int correct(string &st){
    if(st[0] != '-' && !(st[0] >= '0' && st[0] <= '9'))
        return INF;
    return convert(st);
}

string cp(string &s, int st, int fn){
    string ans;
    for(int i = st; i < fn; ++i)
        ans += s[i];
    return ans;
}

void solve(){
    string st;
    vector<string>q;
    while(cin >> st){
        if(st == "{"){
            solve();
            continue;
        }
        if(st == "}")
            break;
        int n = st.length(), p = st.find('=');
        string value1 = cp(st,0,p), value2 = cp(st,p+1,n);
        int num = correct(value2);
        int x = (mp[value2].empty() ? 0 : mp[value2].back());
        int key = (num == INF ? x : num);
        if(num == INF){
            //cout << "AAAAAAAAA" << st.length() << endl;
            //cout << value1 << '=' << value2 << endl;
            printf("%d\n",key);
        }
        mp[value1].push_back(key);
        q.push_back(value1);
    }
    while(!q.empty()){
        mp[q.back()].pop_back();
        q.pop_back();
    }
}

int main()
{
    //freopen("input.txt","r",stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
