import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Stack;

public class TaskC {
	
	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		
		Stack<HashMap<String, Integer>> stack = new Stack<>();
		stack.push(new HashMap<>());
		
		String s;
		while((s = in.readLine()) != null && !s.equals("")) {
			if(s.equals("{")) {
				HashMap<String, Integer> current = new HashMap<>();
				current.putAll(stack.peek());
				stack.push(current);
			} else if(s.equals("}")) {
				stack.pop();
			} else {
				String[] data = s.split("=");
				
				int value;
				if(isInteger(data[1])) {
					value = Integer.parseInt(data[1]);
				} else {
					value = stack.peek().getOrDefault(data[1], 0);
					System.out.println(value);
				}
				stack.peek().put(data[0], value);
			}
		}
	}
	
	private static boolean isInteger(String s) {
		try {
			Integer.parseInt(s);
			return true;
		} catch(Exception e) {
			return false;
		}
	}
	
}
