import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Stack;

public class TaskC {
	
	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		
		HashMap<String, Stack<Integer>> variables = new HashMap<>();
		Stack<HashSet<String>> changed = new Stack<>();
		changed.push(new HashSet<>());
		
		String s;
		while((s = in.readLine()) != null && !s.equals("")) {
			if(s.equals("{")) {
				changed.push(new HashSet<>());
			} else if(s.equals("}")) {
				for(String c : changed.peek()) variables.get(c).pop();
				changed.pop();
			} else {
				String[] data = s.split("=");
				
				int value;
				if(isInteger(data[1])) {
					value = Integer.parseInt(data[1]);
				} else {
					Stack<Integer> stack = variables.get(data[1]);
					if(stack != null && !stack.isEmpty()) {
						value = stack.peek();
					} else {
						value = 0;
					}
					System.out.println(value);
				}
				
				if(!variables.containsKey(data[0])) {
					Stack<Integer> stack = new Stack<>();
					stack.push(value);
					
					changed.peek().add(data[0]);
					variables.put(data[0], stack);
				} else {
					Stack<Integer> stack = variables.get(data[0]);
					
					if(changed.peek().contains(data[0])) {
						stack.pop();
					} else {
						changed.peek().add(data[0]);
					}
					stack.push(value);
				}
			}
		}
	}
	
	private static boolean isInteger(String s) {
		try {
			Integer.parseInt(s);
			return true;
		} catch(Exception e) {
			return false;
		}
	}
	
}
