#include <iostream>
#include <cstdint>
#include <iterator>
#include <utility>
#include <algorithm>
#include <string>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <stack>

using namespace std;

struct Scope {
	Scope* parent;
	unordered_set<string> vars;

	Scope() : parent(nullptr), vars() {

	}

	explicit Scope(Scope* parent) : parent(parent), vars() {

	}
};

int main()
{
	ios::sync_with_stdio(false);
	string line;
	unordered_map<string, stack<int64_t>> data;
	Scope* root = new Scope();
	Scope* cur = root;
	while (getline(cin, line)) {
		if (line[0] == '{') {
			cur = new Scope(cur);
		}
		else if (line[0] == '}') {
			auto* v = cur;
			for (const auto& v : cur->vars) {
				data[v].pop();
			}
			cur = v->parent;
			delete v;
		}
		else {
			auto it = line.find('=');
			string name = line.substr(0, it);
			it++;
			if (isdigit(line[it]) || ((line[it] == '-') && isdigit(line[it + 1]))) {
				const auto v = atoll(line.c_str() + it);
				data[name].push(v);
				cur->vars.insert(name);
			}
			else {
				const auto& ref = line.substr(it);
				const int64_t v = data[ref].empty() ? 0 : data[ref].top();
				data[name].push(v);
				cur->vars.insert(name);
				cout << v << endl;
			}
		}
	}
	delete root;
	return 0;
}