#include<bits/stdc++.h>

#define x first
#define y second
#define sz(s) (int)(s).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define left left228
#define right right228
#define rank rank228
#define y1 y228
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
#define pb push_back
using namespace std;
template<typename T1, typename T2> inline void chkmin(T1 &x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, T2 y) {if (x < y) x = y;}

typedef long long ll;

const int MAXN = 3e5 + 100;
const int ADD = 1e5 + 1;
const string FILENAME = "input";
int n;
const ll INF = 1e18;

int cans = 0;
ll dist[MAXN];
vector<pair<int, ll>> g[MAXN];
pair<ll, ll> te[MAXN];
int p[MAXN];

struct edge {
    int u, v, len, num;
    edge(int _u, int _v, int _len) {
        u = _u, v = _v, len = _len;
    }
};

struct event {
    double x;
    int t, v, u;
    event(double _x, int _t, int _v = 0, int _u = 0) {
        x = _x, t = _t, v = _v, u = _u;
    }
};

vector<edge> edges;
vector<event> evs;

bool cmp(event a, event b) {
    return a.x > b.x;
}

void cnte(int i) {
    int v1 = edges[i].u, v2 = edges[i].v;
    if (dist[v1] > dist[v2]) swap(v1, v2);
    ll t1 = dist[v1], t2 = dist[v2];
    evs.pb(event(dist[v1], 2, v1, i + ADD));
    evs.pb(event(dist[v2], 2, v2, i + ADD));
    ll l = 0, r = edges[i].len + 1;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (mid + max(0ll, mid - (t2 - t1)) >= edges[i].len)
            r = mid;
        else
            l = mid;
    }
    if (r - 0.5 + max(0.0, r - 0.5 - (t2 - t1)) >= edges[i].len)
        evs.pb(event(t1 + r - 0.5, 1, i + ADD));
    else
        evs.pb(event(t1 + r, 1, i + ADD));
}

int get_p(int v) {
    if (p[v] == v) return v;
    return p[v] = get_p(p[v]);
}

bool merge(int u, int v) {
    u = get_p(u), v = get_p(v);
    if (u == v) return false;
    p[u] = v;
    return true;
}

void cntv() {
    for (int i = 1; i < MAXN; ++i)
        p[i] = i;
    int m;
    cin >> m;
    for (int i = 1; i <= n; ++i) dist[i] = INF;
    set<pair<ll, int>> s;
    for (int i = 0; i < m; ++i) {
        int v;
        cin >> v, dist[v] = 0, s.insert({0, v});
    }
    while (!s.empty()) {
        int v = s.begin()->y;
        s.erase(s.begin());
        for (auto u : g[v]) {
            if (dist[u.x] > dist[v] + u.y) {
                s.erase({dist[u.x], u.x});
                dist[u.x] = dist[v] + u.y;
                s.insert({dist[u.x], u.x});
            }
        }
    }
    for (int i = 1; i <= n; ++i)
        evs.pb(event(dist[i], 1, i));
    for (int i = 0; i < edges.size(); ++i) cnte(i);
    sort(all(evs), cmp);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //read(FILENAME);
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        g[u].pb({v, c});
        g[v].pb({u, c});
        edges.pb(edge(v, u, c));
    }
    cntv();
    double ptime = 1e18;
    int ans = 0;
    for (auto i : evs) {
        if (i.x != ptime) {
            chkmax(ans, cans);
        }
        ptime = i.x;
        if (i.t == 1) {
            ++cans;
        }
        else {
            cans -= merge(i.v, i.u);
        }
    }
    chkmax(ans, cans);
    cout << ans;
}

/*
infected 0 8
disconnected 0 1 100001
disconnected 0 1 100002
infected 1 2
infected 1 100006
disconnected 1 3 100006
infected 1 100005
disconnected 1 3 100005
infected 1 100004
disconnected 1 2 100004
infected 1 100003
disconnected 1 2 100003
infected 1 100002
disconnected 1 3 100002
infected 1 100001
disconnected 1 2 100001
infected 1 3
disconnected 2 4 100003
disconnected 2 5 100004
disconnected 2 6 100005
infected 2 7
infected 2 6
disconnected 2 7 100006
infected 2 5
infected 2 4
infected 2 100007
*/
