#include <bits/stdc++.h>
#define double long double

using namespace std;

typedef long long ll;

mt19937 rnd(228);

struct pt
{
    ll x, y;
};

struct ptd
{
    double x, y;
};

ptd operator + (pt a, ptd b)
{
    return {a.x + b.x, a.y + b.y};
}


ptd operator - (pt a, ptd b)
{
    return {a.x - b.x, a.y - b.y};
}

struct line
{
    ll a, b, c;
};

line get(pt a, pt b)
{
    ll A = a.y - b.y;
    ll B = b.x - a.x;
    ll C = -(A * (ll) a.x + B * (ll) a.y);
    return {A, B, C};
}

const double eps = 1e-9;

bool operator != (ptd a, pt b)
{
    return abs(a.x - b.x) >= eps || abs(a.y - b.y) >= eps;
}

bool in(ptd a, pt p, pt q)
{
    return min(p.x, q.x) - eps <= a.x && a.x <= max(p.x, q.x) + eps && min(p.y, q.y) - eps  <= a.y && a.y <= max(p.y, q.y) + eps && (a != p) && (a != q);
}

int sign(double x)
{
    if (x < 0) return -1;
    return 1;
}

int main()
{
    #ifdef ONPC
        freopen("a.in", "r", stdin);
        freopen("a.out", "w", stdout);
    #endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    vector <pt> _a, _b;
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        _a.push_back({x, y});
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; i++)
    {
        int x, y;
        cin >> x >> y;
        _b.push_back({x, y});
    }
    map <pair <int, int>, pair <vector <int>, vector <int> > > e;
    for (int i = 0; i < n; i++)
    {
        int j = (i + 1) % n;
        line cur = get(_a[i], _a[j]);
        if (cur.a < 0)
        {
            cur.a *= -1;
            cur.b *= -1;
            cur.c *= -1;
        }
        if (cur.a == 0)
        {
            if (cur.b < 0)
            {
                cur.a *= -1;
                cur.b *= -1;
                cur.c *= -1;
            }
        }
        int g = __gcd(cur.a, cur.b);
        e[{cur.a / g, cur.b / g}].first.push_back(i);
    }
    for (int i = 0; i < m; i++)
    {
        int j = (i + 1) % m;
        line cur = get(_b[i], _b[j]);
        if (cur.a < 0)
        {
            cur.a *= -1;
            cur.b *= -1;
            cur.c *= -1;
        }
        if (cur.a == 0)
        {
            if (cur.b < 0)
            {
                cur.a *= -1;
                cur.b *= -1;
                cur.c *= -1;
            }
        }
        int g = __gcd(cur.a, cur.b);
        e[{cur.a / g, cur.b / g}].second.push_back(i);
    }
    for (auto c : e)
    {
        for (auto x : c.second.first)
        {
            for (auto y : c.second.second)
            {
                int i = x, j = y;
                line A = get(_a[i], _a[(i + 1) % n]);
                line B = get(_b[j], _b[(j + 1) % m]);
                if (A.a < 0)
                {
                    A.a *= -1;
                    A.b *= -1;
                    A.c *= -1;
                }
                if (A.a == 0 && A.b < 0)
                {

                    A.a *= -1;
                    A.b *= -1;
                    A.c *= -1;
                }
                if (B.a < 0)
                {
                    B.a *= -1;
                    B.b *= -1;
                    B.c *= -1;
                }
                if (B.a == 0 && B.b < 0)
                {
                    B.a *= -1;
                    B.b *= -1;
                    B.c *= -1;
                }
                double a = A.a, b = A.b, c = A.c;
                double len = sqrt(a * a + b * b);
                a /= len;
                b /= len;
                c /= len;
                int ot = (j + 2) % m;
                double f1 = a * _a[i].x + b * _a[i].y + c;
                double f2 = a * _b[ot].x + b * _b[ot].y + c;
                if (sign(f1) == sign(f2)) continue;
                double a1 = B.a, b1 = B.b, c1 = B.c;
                double len1 = sqrt(a1 * a1 + b1 * b1);
                a1 /= len1;
                b1 /= len1;
                c1 /= len1;
                double rz = c1 - c;
                ptd cur = {a, b};
                cur.x *= rz;
                cur.y *= rz;
                if (in(_a[i] + cur, _b[j], _b[(j + 1) % m]))
                {
                    cout << "YES\n";
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    return 0;
                }
                if (in(_a[(i + 1) % n] + cur, _b[j], _b[(j + 1) % m]))
                {
                    cout << "YES\n";
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    return 0;
                }
                ptd kek = {_a[i].x, _a[i].y};
                kek.x += _a[(i + 1) % n].x;
                kek.y += _a[(i + 1) % n].y;
                kek.x /= 2;
                kek.y /= 2;
                kek.x += cur.x;
                kek.y += cur.y;
                if (in(kek, _b[j], _b[(j + 1) % m]))
                {
                    cout << "YES\n";
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    return 0;
                }
                if (in(_b[j] - cur, _a[i], _a[(i + 1) % n]))
                {
                    cout << "YES\n";
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    return 0;
                }
                if (in(_b[(j + 1) % m] - cur, _a[i], _a[(i + 1) % n]))
                {
                    cout << "YES\n";
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    return 0;
                }
            }
        }
    }
    cout << "NO\n";
    return 0;
}
