#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> gr;
const long long INF = (long long) 1e18;

struct Event {
    long long t;
    int type;
    int ind;

    Event(long long int t, int type, int ind) : t(t), type(type), ind(ind) {}
};

bool cmp(const Event &e1, const Event &e2) {
    return e1.t < e2.t;
}

struct Edge {
    int id;
    int u, v, w;

    Edge(int id, int u, int v, int w) : id(id), u(u), v(v), w(w) {}
};

vector<vector<Edge>> gr1;

int nv() {
    gr1.push_back(vector<Edge>());
    return gr1.size() - 1;
}

void adde(int a, int b, int w) {
    Edge e(0, a, b, w);
    gr1[a].push_back(e);
    gr1[b].push_back(e);
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    gr.resize(n);
    vector<Edge> el;
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        w *= 2;
        u--;
        v--;
        el.push_back(Edge(i, u, v, w));
        gr[u].push_back(i);
        gr[v].push_back(i);
    }

    vector<long long> t(n, INF);
    int m;
    cin >> m;
    vector<int> start(m);
    set<pair<long long, int>> st;
    for (int i = 0; i < m; i++) {
        int a;
        cin >> a;
        a--;
        start[i] = a;
        t[a] = 0;
        st.insert({0, a});
    }

    while (!st.empty()) {
        auto p = *st.begin();
        st.erase(p);
        int u = p.second;

        for (int e : gr[u]) {
            int w = el[e].w;
            int v = el[e].u == u ? el[e].v : el[e].u;
            if (t[v] > t[u] + w) {
                st.erase({t[v], v});
                t[v] = t[u] + w;
                st.insert({t[v], v});
            }
        }
    }

    for (int i = 0; i < n; i++) {
        nv();
    }

    for (auto e : el) {
        long long t1 = t[e.u];
        long long t2 = t[e.v];
        long long l = e.w;
        if (t1 + l <= t2 || t2 + l <= t1) {
            adde(e.u, e.v, e.w);
        } else {
            long long tt = (t1 + t2 + l) / 2;
            int l1 = (int) (tt - t1);
            int l2 = (int) (tt - t2);
            int x = nv();
            adde(e.u, x, l1);
            adde(x, e.v, l2);
        }
    }

    t.assign(gr1.size(), INF);
    st.clear();
    for (int i : start) {
        t[i] = 0;
        st.insert({t[i], i});
    }

    while (!st.empty()) {
        auto p = *st.begin();
        st.erase(p);
        int u = p.second;

        for (auto e : gr1[u]) {
            int v = e.u == u ? e.v : e.u;
            if (t[v] > t[u] + e.w) {
                st.erase({t[v], v});
                t[v] = t[u] + e.w;
                st.insert({t[v], v});
            }
        }
    }

    vector<pair<long long, int>> evs;
    vector<bool> alive(gr1.size(), true);
    for (int i = 0; i < gr1.size(); i++) {
        evs.push_back({t[i], i});
    }
    sort(evs.begin(), evs.end());
    int comps = 1;
    int mx = 0;
    for (int i = 0; i < evs.size(); i++) {
        int cnt = 0;
        int v = evs[i].second;
        for (auto e : gr1[v]) {
            int u = e.v == v ? e.u : e.v;
            if (alive[u]) {
                cnt++;
            }
        }

        alive[v] = false;
        comps += cnt - 1;

        if (i + 1 == evs.size() || evs[i + 1].first > evs[i].first) {
            mx = max(mx, comps);
        }
    }

    cout << mx << endl;

    return 0;
}