#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <map>

using namespace std;

void run();

typedef long long ll;

const ll LINF = (ll) 1e18 + 123;

#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define sz(x) ((int) (x).size())

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << endl << "OK" << endl;
	while (1);
#endif
	return 0;
}

const int N = (int) 1e5 + 123;
const ll MOD = (ll) 1e9 + 7;

int n;
int a[N];
map<int, vector<int>> pos;
int prv[N], nxt[N];

void run() {
	cin >> n;
	rep(i, 0, n) {
		cin >> a[i];
		pos[a[i]].push_back(i);
	}

	{
		vector<int> st;
		rep(i, 0, n) {
			while (sz(st) && a[st.back()] <= a[i]) {
				st.pop_back();
			}
			if (sz(st)) {
				prv[i] = st.back();
			}
			else {
				prv[i] = -1;
			}
			st.push_back(i);
		}
	}

	{
		vector<int> st;
		per(i, n - 1, 0) {
			while (sz(st) && a[st.back()] <= a[i]) {
				st.pop_back();
			}
			if (sz(st)) {
				nxt[i] = st.back();
			}
			else {
				nxt[i] = n;
			}
			st.push_back(i);
		}
	}

	ll ans = 0;

	for (auto &it : pos) {
		auto &v = it.second;
		rep(i, 0, sz(v) - 1) {
			int a = v[i];
			int b = v[i + 1];
			ll left_a = a - prv[a];
			ll right_b = nxt[b] - b;
			int q = nxt[a];
			if (q < b) {
				ll right_a = nxt[a] - a;
				ll left_b = b - prv[b];
				ans += left_a * right_a % MOD * left_b % MOD * right_b % MOD;
				ans %= MOD;
			}
			else {
				ll len = b - a + 1;
				ll here = len * (len - 1) / 2;
				here %= MOD;
				ans += left_a * right_b % MOD * here % MOD;
				ans %= MOD;
			}
		}
		ll prv_sum = 0;
		ll toadd = 0;
		rep(i, 0, sz(v)) {
			int a = -1;
			if (i > 0) {
				a = v[i - 1];
			}
			int b = v[i];
			ll right_b = nxt[b] - b;
			ll left_b = b - max(a, prv[b]);
			ll my = right_b * left_b % MOD;
			ans += my * prv_sum % MOD;
			ans %= MOD;

			prv_sum += toadd;
			prv_sum %= MOD;

			{
				int c = n;
				if (i != sz(v) - 1) {
					c = v[i + 1];
				}
				right_b = min(c, nxt[b]) - b;
				left_b = b - prv[b];
				my = right_b * left_b % MOD;
				toadd = my;
			}
		}
	}

	cout << ans << "\n";
}