#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

void run();

typedef long long ll;

const ll LINF = (ll) 1e18 + 123;

#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define sz(x) ((int) (x).size())

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << endl << "OK" << endl;
	while (1);
#endif
	return 0;
}

#define int long long
const int N = (int) 1e5 + 123;
const ll INF = (ll) 1e18 + 123;

int n;
struct Edge {
	int u, v, l;
};
Edge e[N];
bool killed_v[N];
bool killed_e[N];
vector<int> g[N];
int momk[N];
int m;

struct Event {
	int moment;
	bool type;
	int id;

	bool operator<(const Event &e) const {
		return make_pair(moment, make_pair(type, id)) < make_pair(e.moment, make_pair(e.type, e.id));
	}
};

void run() {
	cin >> n;
	rep(i, 0, n - 1) {
		cin >> e[i].u >> e[i].v >> e[i].l;
		e[i].l *= 2;
		g[e[i].u].push_back(i);
		g[e[i].v].push_back(i);
	}
	fill(momk, momk + N, INF);
	cin >> m;
	set<Event> evs;
	rep(i, 0, m) {
		int v;
		cin >> v;
		evs.insert({ 0, 0, v });
		momk[v] = 0;
	}
	vector<Event> tmp;
	int cnt = 1;
	int ans = 0;
	while (sz(evs)) {
		int moment = evs.begin()->moment;
		while (sz(evs) && evs.begin()->moment == moment) {
			tmp.push_back(*evs.begin());
			evs.erase(evs.begin());
		}

		for (Event ev : tmp) {
			if (ev.type == 1) {
				if (!killed_e[ev.id]) {
					cnt--;
					killed_e[ev.id] = 1;
				}
			}
			else {
				int v = ev.id;
				if (killed_v[v]) {
					continue;
				}
				momk[v] = moment;
				killed_v[v] = 1;
				cnt--;
				for (int eid : g[v]) {
					int u = (e[eid].u != v ? e[eid].u : e[eid].v);
					if (killed_v[u]) {
						if (momk[u] + e[eid].l > moment) {
							cnt++;
							int dist = momk[u] + e[eid].l - moment;
							evs.insert({ dist, 1, eid });
						}
					}
					else {
						cnt++;
						evs.insert({ moment + e[eid].l, 0, u });
					}
				}
			}
		}
		ans = max(ans, cnt);
		tmp.clear();
	}
	cout << ans << "\n";
}