#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <unordered_map>
#include <map>
#include <cassert>

using namespace std;

void run();

typedef long long ll;

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;

#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define sz(x) ((int) (x).size())

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << endl << "OK" << endl;
	while (1);
#endif
	return 0;
}

const int N = 1 << 11;

struct Tree {
	int val[2 * N];

	Tree() {
		fill(val, val + 2 * N, INF);
	}

	void upd(int i, int tl, int tr, int ind, int x) {
		if (tl == tr - 1) {
			val[i] = x;
			return;
		}
		int tm = (tl + tr) / 2;
		if (ind < tm) {
			upd(2 * i + 1, tl, tm, ind, x);
		}
		else {
			upd(2 * i + 2, tm, tr, ind, x);
		}
		val[i] = min(val[2 * i + 1], val[2 * i + 2]);
	}

	int get(int i, int tl, int tr, int l, int r) {
		if (r <= tl || l >= tr) {
			return INF;
		}
		if (l <= tl && tr <= r) {
			return val[i];
		}
		int tm = (tl + tr) / 2;
		return min(get(2 * i + 1, tl, tm, l, r), get(2 * i + 2, tm, tr, l, r));
	}

	void upd(int ind, int x) {
		upd(0, 0, N, ind, x);
	}

	int get(int l, int r) {
		return get(0, 0, N, l, r + 1);
	}
};

int n, m;
Tree dp[N];
int d[N], c[N], p[N];
map<int, vector<int>> qq;
pair<int, int> from[N][N];

void run() {
	cin >> n >> m;
	rep(i, 0, n) {
		cin >> d[i] >> p[i] >> c[i];
		qq[d[i]].push_back(i);
	}
	int ptr = 0;
	for (auto &it : qq) {
		for (int v : it.second) {
			d[v] = ptr;
		}
		ptr++;
	}
	dp[0].upd(N - 1, 0);
	rep(i, 0, n) {
		per(layer, m - 1, 0) {
			int to = min(m, layer + p[i]);
			int val = dp[layer].get(d[i], N - 1);
			if (val + c[i] < dp[to].get(d[i], d[i])) {
				dp[to].upd(d[i], val + c[i]);
				from[to][d[i]] = {layer, i};
			}
		}
	}
	int res = dp[m].get(0, N - 1);
	if (res == INF) {
		cout << "-1\n";
		return;
	}

	vector<int> take;

	int pos = -1;
	rep(i, 0, N) {
		if (dp[m].get(i, i) == res) {
			pos = i;
			break;
		}
	}
	assert(pos != -1);
	int tt = from[m][pos].second;
	int dd = d[tt];
	int layer = from[m][pos].first;
	int cur = res - c[tt];
	take.push_back(tt);
	while (layer > 0) {
		int qq = -1;
		rep(i, dd, N) {
			if (dp[layer].get(i, i) == cur) {
				qq = i;
				break;
			}
		}
		assert(qq != -1);
		tt = from[layer][qq].second;
		take.push_back(tt);
		cur -= c[tt];
		dd = qq;
		layer = from[layer][qq].first;
	}

	cout << res << " " << sz(take) << "\n";
	reverse(take.begin(), take.end());
	for (int x : take) {
		cout << x + 1 << " ";
	}
	cout << "\n";
}