#include <cstdio>
#include <bits/stdc++.h>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef double ld;

const int N = 100001;
const ll INF = 100000000000000000;
const ld eps = 1e-8;

struct Point
{
    ld x, y;
    Point():
        x(0),
        y(0) {}
    Point(ld x, ld y):
        x(x),
        y(y) {}
    ld operator*(Point p)
    {
        return p.x * x + p.y * y;
    }
    ld operator%(Point p)
    {
        return x * p.y - y * p.x;
    }
    Point operator+(Point p)
    {
        return Point(x + p.x, y + p.y);
    }
    Point operator-()
    {
        return Point(-x, -y);
    }
    Point operator-(Point p)
    {
        return Point(x - p.x, y - p.y);
    }
};

struct Line
{
    ld a, b, c;
    Line():
        a(0),
        b(0),
        c(0) {}
    Line(ld a, ld b, ld c):
        a(a),
        b(b),
        c(c) {}
    Line(Point p, Point q):
        a(p.y - q.y),
        b(q.x - p.x),
        c(p.x * (q.y - p.y) + p.y * (p.x - q.x)) {}
    ld dist(Point p)
    {
        return p.x * a + p.y * b + c;
    }
};

vector<Point> a, b;

int main()
{
    ios::sync_with_stdio(0); cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        Point p;
        cin >> p.x >> p.y;
        a.push_back(p);
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; i++)
    {
        Point p;
        cin >> p.x >> p.y;
        b.push_back(p);
    }
    for (int i = 0; i < n; i++)
    {
        Point p = a[(i + 1) % n] - a[i];
        Point s = b[1] - b[0];
        int l = 0, r = m;
        if (p % s > eps)
        {
            while (r - l > 1)
            {
                int mid = (r + l) / 2;
                Point q = b[(mid + 1) % m] - b[mid];
                if ((p % q > -eps && s % q < -eps))
                    r = mid;
                else
                    l = mid;
            }
        }
        else
        {
            while (r - l > 1)
            {
                int mid = (r + l) / 2;
                Point q = b[(mid + 1) % m] - b[mid];
                if ((p % q < eps && s % q > eps))
                    l = mid;
                else
                    r  = mid;
            }
            r = l;
        }
        Point q = b[(r + 1) % m] - b[r];
        Point x = a[i], y = a[(i + 1) % n], z = b[r], t = b[(r + 1) % m];
        if (abs(q % p) < eps && p * q > 0)
        {
            bool ok = false;
            Point kek = (x + y);
            kek.x /= (ld)2;
            kek.y /= (ld)2;
            if (((x - z) * (t - z) > eps && ((x - t) * (z - t) > eps)) ||
                ((y - z) * (t - z) > eps && ((y - t) * (z - t) > eps)))
                ok = true;
            if (((kek - z) * (t - z) > eps && ((kek - t) * (z - t) > eps)))
                ok = true;
            swap(x, z);
            swap(y, t);
            if (((x - z) * (t - z) > eps && ((x - t) * (z - t) > eps)) ||
                ((y - z) * (t - z) > eps && ((y - t) * (z - t) > eps)))
                ok = true;
           // cout << (int)ok << endl;
            swap(x, z);
            swap(y, t);
            if (ok)
            {
                Point g = b[(r + 2) % m];
                Point f = a[(i + 2) % n];
                Line l = Line(x, y), k = Line(z, t);
                if (l.dist(f) * l.dist(b[r]) < -eps && k.dist(g) * k.dist(a[i]) < -eps)
                {
                    cout << "YES";
                    cout << i + 1 << " " << r + 1;
                    return 0;
                }

            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        Point p = a[i] - a[(i + 1) % n];
        Point s = b[1] - b[0];
        int l = 0, r = m;
        if (p % s > eps)
        {
            while (r - l > 1)
            {
                int mid = (r + l) / 2;
                Point q = b[(mid + 1) % m] - b[mid];
                if ((p % q > -eps && s % q < -eps))
                    r = mid;
                else
                    l = mid;
            }
        }
        else
        {
            while (r - l > 1)
            {
                int mid = (r + l) / 2;
                Point q = b[(mid + 1) % m] - b[mid];
                if ((p % q < eps && s % q > eps))
                    l = mid;
                else
                    r  = mid;
            }
            r = l;
        }
        Point q = b[(r + 1) % m] - b[r];
        Point x = a[i], y = a[(i + 1) % n], z = b[r], t = b[(r + 1) % m];
        if (abs(q % p) < eps && p * q > 0)
        {
           //  cout << i + 1 << " " << r + 1 << endl;
            bool ok = false;
            Point kek = (x + y);
            kek.x /= (ld)2;
            kek.y /= (ld)2;
            if (((x - z) * (t - z) > eps && ((x - t) * (z - t) > eps)) ||
                ((y - z) * (t - z) > eps && ((y - t) * (z - t) > eps)))
                ok = true;
            if (((kek - z) * (t - z) > eps && ((kek - t) * (z - t) > eps)))
                ok = true;
            swap(x, z);
            swap(y, t);
            if (((x - z) * (t - z) > eps && ((x - t) * (z - t) > eps)) ||
                ((y - z) * (t - z) > eps && ((y - t) * (z - t) > eps)))
                ok = true;
           // cout << (int)ok << endl;
            swap(x, z);
            swap(y, t);
            if (ok)
            {
                Point g = b[(r + 2) % m];
                Point f = a[(i + 2) % n];
                Line l = Line(x, y), k = Line(z, t);
                if (l.dist(f) * l.dist(b[r]) < -eps && k.dist(g) * k.dist(a[i]) < -eps)
                {
                    cout << "YES ";
                    cout << i + 1 << " " << r + 1;
                    return 0;
                }

            }
        }
    }
    cout << "NO";
    return 0;
    return 0;
}
/*
3
0 0
1 0
0 1
3
0 -1
0 -2
1 -1

3
0 0
1 0
0 1
3
1 -1
1 -2
2 -1

4
-1 0
0 0
0 1
-1 1
4
1 0
0 -1
1 -2
2 -1
*/
