#include <bits/stdc++.h>

using namespace std;

#define int int64_t

struct Point {
    int x, y;
    Point(int x = 0, int y = 0):
        x(x), y(y) {}
};

struct Vector {
    int x, y;
    Vector(int x = 0, int y = 0):
        x(x), y(y) {}
    Vector(Point a, Point b):
        x(b.x - a.x), y(b.y - a.y) {}
    bool operator<(const Vector &t) const
    {
        return make_pair(x, y) < make_pair(t.x, t.y);
    }
    int operator*(const Vector &t) const
    {
        return (x * t.x + y * t.y);
    }
    int operator^(const Vector &t) const
    {
        return (x * t.y - y * t.x);
    }
};

vector <Point> f1, f2;
int n, m;

bool memkek(Point p, Point a, Point b)
{
    return ((Vector(a, p) * Vector(a, b)) > 0 && (Vector(b, p) * Vector(b, a)) > 0);
}

bool memkekkek(Point p, Point a, Point b)
{
    return ((Vector(a, p) * Vector(a, b)) == 0 || (Vector(b, p) * Vector(b, a)) == 0);
}

int sign(int a) {
    if (a > 0)
        return 1;
    if (a == 0)
        return 0;
    return -1;
}

bool kek(Point a, Point b, Point x, Point y) {
    return sign(Vector(a, b) ^ Vector(a, x)) * sign(Vector(a, b) ^ Vector(a, y)) != 1;
}

Point Middle(Point a, Point b) { return Point((a.x + b.x) / 2, (a.y + b.y) / 2); }

bool lolkekcheburek(Point a, Point b, Point c, Point d) {
    return memkekkek(c, a, b) && memkekkek(d, a, b);
}

bool check(int a, int b)
{
    Vector v1 = Vector(f1[a], f1[(a + 1) % n]);
    Vector v2 = Vector(f2[b], f2[(b + 1) % m]);
    bool ok = false;
    ok |= memkek(f1[a], f2[b], f2[(b + 1) % m]);
    ok |= memkek(f1[(a + 1) % n], f2[b], f2[(b + 1) % m]);
    ok |= memkek(f2[b], f1[a], f1[(a + 1) % n]);
    ok |= memkek(f2[(b + 1) % m], f1[a], f1[(a + 1) % n]);
    ok |= lolkekcheburek(f1[a], f1[(a + 1) % n], f2[b], f2[(b + 1) % m]);
    if (!ok) return false;
    Point p = f2[(b + 2) % m];
    Point q = f1[(a + 2) % n];

    return kek(f2[b], f2[(b + 1) % m], p, f1[a]) && kek(f1[a], f1[(a + 1) % n], q, f2[b]);
}

Vector normal(Vector a)
{
    if (a.y < 0)
        a.x = -a.x, a.y = -a.y;
    if (a.y == 0 && a.x < 0)
        a.x = -a.x, a.y = -a.y;
    int g = __gcd(a.x, a.y);
    a.x /= g, a.y /= g;
    return a;
}

map<Vector, vector<int> > nums;

int32_t main() {
    //freopen("input.txt", "r", stdin);

    cin >> n;
    f1.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> f1[i].x >> f1[i].y;
    }

    cin >> m;
    f2.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> f2[i].x >> f2[i].y;
    }

    for (int i = 0; i < n; i++) {
        Vector v(f1[i], f1[(i + 1) % n]);
        Vector t = normal(v);
        nums[t].push_back(i);
    }

    for (int i = 0; i < m; i++) {
        Vector v(f2[i], f2[(i + 1) % m]);
        Vector t = normal(v);
        for (int x : nums[t])
        {
            if (check(x, i))
            {
                cout << "YES\n" << x + 1 << " " << i + 1;
                return 0;
            }
        }
    }
    cout << "NO";
    return 0;
}
