#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second

using namespace std;

const int INF = 2e9;
const int maxN = 100000;

pair<string, int> parseName(int i, const string& s) {
    string res;

    while (i < s.size() && s[i] != '=') {
        res += s[i];
        i++;
    }

    return {res, i};
}

int parseNum(int i, const string& s) {
    int res = 0;
    bool b = 0;
    if (s[i] == '-') b = 1, i++;
    while (i < s.size()) {
        res *= 10;
        res += s[i] - '0';
        i++;
    }

    return res * (b ? -1 : 1);
}

map<string, vector<pair<int, int>>> val;

int getVal(int lvl, string& name) {
    if (!val.count(name)) return 0;

    while (val[name].size() > 0 && val[name].back().first > lvl) val[name].pop_back();
    if (val[name].size() == 0) return 0;
    return val[name].back().second;
}

void setVal(int nval, int lvl, string& name) {
    if (!val.count(name)) {
        val[name] = vector<pair<int, int>>();
        val[name].push_back({lvl, nval});
        return;
    }

    while (val[name].size() > 0 && val[name].back().first >= lvl) val[name].pop_back();
    val[name].push_back({lvl, nval});
}

/*
a=b
b=123
var=b
b=-34
{
c=b
b=1000000000
d=b
{
a=b
e=var
}
}
b=b
*/

vector<string> nv[maxN];

int main()
{
    //freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int lvl = 0;
    string s;
    while (cin >> s) {
        if (s == "{") {
            lvl++;
            continue;
        }
        if (s == "}") {
            for (string n : nv[lvl]) {
                while (val[n].size() > 0 && val[n].back().first >= lvl) val[n].pop_back();
            }

            lvl--;
            continue;
        }

        auto p1 = parseName(0, s);
        int i = p1.second + 1;

        nv[lvl].push_back(p1.first);

        int nval;
        bool b = 0;
        if (s[i] >= 'a' && s[i] <= 'z') {
            b = 1;
            auto p2 = parseName(i, s);

            nval = getVal(lvl, p2.first);
        }
        else {
            nval = parseNum(i, s);
        }

        setVal(nval, lvl, p1.first);

        if (b) {
                cout << nval << "\n";
        }
    }

    return 0;
}
