#include <bits/stdc++.h>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

struct e
{
    int u, v;
    ll c;
};

const int MAXN = 1e5 + 10;
vector <int> g[MAXN];

struct q
{
    ll time;
    int city;
    int ind;
    bool operator <(const q &other) const
    {
        return time > other.time;
    }
};

struct dsu
{
    vector <int> rnk;
    vector <int> cmp;
    dsu(int n)
    {
        rnk.resize(n);
        cmp.resize(n);
        for (int i = 0; i < n; i++)
            cmp[i] = i;
    }
    int get(int u)
    {
        return (cmp[u] == u ? u : cmp[u] = get(cmp[u]));
    }
    bool merge(int u, int v)
    {
        u = get(u);
        v = get(v);
        if (u == v)
            return 1;
        if (rnk[u] < rnk[v])
            swap(u, v);
        if (rnk[u] == rnk[v])
            rnk[u]++;
        cmp[v] = u;
        return 0;
    }
};

int main()
{
    srand(1337);
    //freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    int n;
    cin >> n;
    vector <e> es(n - 1);
    for (int i = 0; i < n - 1; i++)
    {
        cin >> es[i].u >> es[i].v >> es[i].c;
        es[i].c *= 2;
        g[es[i].u].push_back(i);
        g[es[i].v].push_back(i);
    }
    vector <ll> dist(n + 10);
    set <pair <ll, int>> st;
    int m;
    cin >> m;
    for (int i = 0; i < m; i++)
    {
        int u;
        cin >> u;
        dist[u] = 0;
        st.insert({0, u});
    }
    while (!st.empty())
    {
        auto tp = *st.begin();
        st.erase(st.begin());
        int u = tp.second;
        for (int i : g[u])
        {
            int v = (es[i].u == u ? es[i].v : es[i].u);
            ll nw = tp.first + es[i].c;
            if (nw < dist[v])
            {
                st.erase({dist[v], v});
                dist[v] = nw;
                st.insert({dist[v], v});
            }
        }
    }
    vector <q> qs;
    for (int i = 1; i <= n; i++)
    {
        qs.push_back({dist[i], 1, i});
    }
    for (int i = 0; i < n - 1; i++)
    {
        ll x1 = dist[es[i].u];
        ll x2 = dist[es[i].v];
        if (x1 > x2)
            swap(x1, x2);
        ll time = 0;
        if (x2 - x1 >= es[i].c)
            time = x1 + es[i].c;
        else
            time = x1 + (x2 - x1) + (es[i].c - x2 + x1) / 2;

        qs.push_back({x1, 2, i});
        qs.push_back({time, 3, i});
    }
    sort(qs.begin(), qs.end());

    dsu kek(2 * n + 6);
    vector <bool > usedn, usedm;
    usedn.resize(n, 0);
    usedm.resize(n - 1, 0);
    int ans = 0;
    int cur = 1;
    int flag = 0;
    for (q i : qs)
    {
        if (i.city == 1)
        {
            usedn[i.ind] = 1;
            flag = 1;
            for (int j = 0; j < g[i.ind].size(); j++)
                if (usedm[g[i.ind][j]])
                {
                    flag--;
                    kek.merge(i.ind, n + 1 + g[i.ind][j]);
                }
            cur += flag;
        }
        if (i.city == 3)
            usedm[i.ind] = 1;
        if (i.city == 2)
        {
            flag = 1;
            if (usedn[es[i.ind].u])
            {
                flag -= (!kek.merge(i.ind + n + 1, es[i.ind].u));
            }
            if (usedn[es[i.ind].v] && (usedn[es[i.ind].u] || kek.get(es[i.ind].u) != kek.get(es[i.ind].v)))
            {
                flag -= (!kek.merge(i.ind + n + 1, es[i.ind].v));
            }
            cur += flag;
        }
        ans = max(ans, cur);
    }
    cout << ans;
    return 0;
}
