#include <bits/stdc++.h>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

const int MAXN = 2100;
const ll INF = 1e18;

struct T
{
    T *l, *r;
    ll x;
    ll mn;
    ll y;
    ll key;
    ll ind;
    ll mn_ind;
    T (ll x_, ll key_, ll ind_)
    {
        l = 0;
        r = 0;
        y = (rand() << 15) ^ rand();
        x = x_;
        mn = x;
        key = key_;
        ind = ind_;
        mn_ind = ind;
    }
    void upd()
    {
        mn = x;
        mn_ind = ind;
        if (l)
        {
            if (mn > l->mn)
                mn_ind = l->mn_ind;
            mn = min(mn, l->mn);
        }
        if (r)
        {
            if (mn > r->mn)
                mn_ind = r->mn_ind;
            mn = min(mn, r->mn);
        }
    }
    void print()
    {
        if (!this)
            return;
        l->print();
        cout << x << " ";
        r->print();
    }
};

pair <T*, T*> split(T *root, ll key)
{
    if (!root)
        return {0, 0};
    if (root->key > key)
    {
        auto res = split(root->l, key);
        root->l = res.second;
        root->upd();
        return {res.first, root};
    }
    else
    {
        auto res = split(root->r, key);
        root->r = res.first;
        root->upd();
        return {root, res.second};
    }
}
T* merge(T *cl, T *cr)
{
    if (!cl)
        return cr;
    if (!cr)
        return cl;
    if (cl->y < cr->y)
    {
        cr->l = merge(cl, cr->l);
        cr->upd();
        return cr;
    }
    else
    {
        cl->r = merge(cl->r, cr);
        cl->upd();
        return cl;
    }
}

ll dp[MAXN][MAXN];
ll prv[MAXN][MAXN];
T *ts[MAXN];

void add(int num, ll x, ll key, ll ind)
{
    auto res = split(ts[num], key);
    T *nw = new T(x, key, ind);
    res.first = merge(res.first, nw);
    ts[num] = merge(res.first, res.second);
}

pair <ll, ll> get(ll num, ll key)
{
    auto res = split(ts[num], key - 1);
    return (res.second ? make_pair(res.second->mn, res.second->mn_ind) : make_pair(INF, INF));
}

int main()
{
 //   freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    for (int i = 0; i < MAXN; i++)
    {
        add(i, INF, INF, INF);
        for (int j = 0; j < MAXN; j++)
        {
            dp[i][j] = INF;
            prv[i][j] = -1;
        }
    }
    int n, m;
    cin >> n >> m;
    vector <int> d(n), c(n), p(n);
    for (int i = 0; i < n; i++)
        cin >> d[i] >> c[i] >> p[i];
    dp[0][0] = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            if (j - c[i] <= 0)
                dp[i][j] = p[i];
            else
            {
                auto res = get(j - c[i], d[i]);
                ll kek = res.first + p[i];
                if (dp[i][j] > kek)
                {
                    dp[i][j] = kek;
                    prv[i][j] = res.second;
                }
            }
        }
        for (int j = 1; j <= m; j++)
        {
            add(j, dp[i][j], d[i], i);
     //       cout << i << " " << j << " " << dp[i][j] << "\n";
        }
    }
    ll ans = INF, ansind;
    for (int i = 0; i < n; i++)
    {
        if (ans > dp[i][m])
            ansind = i;
        ans = min(ans, dp[i][m]);
    }
    if (ans == INF)
        return cout << -1, 0;
    vector <ll> a;
    while (ansind != -1)
    {
        ll old = m;
        m -= c[ansind];
        a.push_back(ansind);
        ansind = prv[ansind][old];
    }
    cout << ans << " " << a.size() << "\n";
    reverse(a.begin(), a.end());
    for (int i : a)
        cout << i + 1 << " ";
    return 0;
}
