import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

public class C {
    public static String[] code;

    public static int findClosed(int start) {
        int b = 1;
        int cur = start + 1;
        while (b > 0) {
            if (code[cur].equals("{")) {
                b++;
            } else if (code[cur].equals("}")) {
                b--;
            }
            cur++;
        }
        return cur - 1;
    }

    static void exec(int first, int last, Map<String, String> vars) {
        int current = first;

        while (current < last) {
            String command = code[current];

            if (command.equals("{")) {
                int closedInd = findClosed(current);
                exec(current + 1, closedInd, new HashMap<>(vars));
                current = closedInd;
            } else if (!command.equals("}")) {
                String[] ss = command.split("=");
                String name = ss[0];
                String value = ss[1];
                boolean needOut = false;
                try {
                    Integer.parseInt(value);
                } catch (NumberFormatException e) {
                    needOut = true;
                    if (vars.containsKey(value)) {
                        value = vars.get(value);
                    } else {
                        value = "0";
                    }
                }
                vars.put(name, value);
                if (needOut) {
                    System.out.println(value);
                }
                current++;
            } else {
                current++;
            }
        }
    }

    public static void main(String[] args) throws IOException {
        // BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream("input.in")));
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        ArrayList<String> input = new ArrayList<>();
        while (reader.ready()) {
            input.add(reader.readLine());
        }
        code = new String[input.size()];
        code = input.toArray(code);
        exec(0, code.length, new HashMap<String, String>());
    }
}
