#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <set>
#include <algorithm>
#include <iomanip>
#include <map>
#include <string>
#include <vector>
using namespace std;

const int len = 1e6;
bool r[len + 1];

bool used[len + 1];

int ln(long long x) {
	int ans = 0;
	while (x > 0) {
		x /= 10;
		ans++;
	}
	return ans;
}

long long pw(long long x, long long y) {
	if (y == 0)
		return 1;
	return x * pw(x, y - 1);
}

long long from, to;
long long ans = 0;

bool isPrime(long long val) {
	if (val == 2)
		return true;
	if (val == 1)
		return false;
	if (val % 2 == 0)
		return false;
	for (long long i = 3; i * i <= val; i += 2)
		if (val % i == 0)
			return false;
	return true;
}

void run(long long f) {
	if (f <= len && used[f])
		return;
	if (f < 0)
		return;

	if (!isPrime(f))
		return;

	if(f < len)
		used[f] = true;
	
	if (from <= f && f <= to) {
		ans++;
	}
	if (f >= to)
		return;
	for (int i = 1; i <= 9; i++) {
		run(f + pw(10, ln(f)) * i);
	}
}

bool ok(int x) {
	int y = x;
	while (y > 0) {
		if (y % 10 == 0)
			return false;
		y /= 10;
	}
	while (x > 0) {
		int f = ln(x);
		while (f == ln(x))
			x -= pw(10, ln(x) - 1);
		if (x == 0)
			return true;
		if (!isPrime(x))
			return false;
	}
	return true;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> from >> to;
	for (int i = 2; i <= len; i++)
		r[i] = true;
	vector < int > p;
	for (long long i = 2; i <= len; i++) {
		if (r[i]) {
			if (ok(i)) {
				p.push_back(i);
			}
			for (long long j = i * i; j <= len; j += i) {
				r[j] = false;
			}
		}
	}
	for (int i = 0; i < p.size(); i++) {
		run(p[i]);
	}
	cout << ans;
}