#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

const int N = (int)1e5 + 7;
const long long INF = 1e16;

struct Edge {
	int ver, w, t1, t2, all, type;
};

int cnt[N] = {}, n, ed[N];
long long tp[N];
vector <Edge> gr[N];
vector <pair<int, int>> line;

void min_path() {
	set <pair<int, int>> q;
	for (int i = 1; i <= n; i++)
		if (tp[i] != INF)
			q.insert(make_pair(0, i));
	bool used[N] = {};
	while (!q.empty()) {
		int v = (*q.begin()).second;
		q.erase(q.begin());
		for (Edge e : gr[v]) {
			int to = e.ver;
			long long len = e.w;
			if (tp[to] > tp[v] + e.w) {
				if (q.find(make_pair(tp[to], to)) != q.end())
					q.erase(q.find(make_pair(tp[to], to)));
				tp[to] = e.w + tp[v];
				q.insert(make_pair(tp[to], to));
			}
		}
	}
}

void dfs(int v, int p = -1) {
	line.push_back(make_pair(tp[v], v));
	for (Edge e : gr[v]) {
		ed[v]++;
		int to = e.ver;
		e.t1 = tp[v];
		e.t2 = tp[to];
		int mn = min(e.t1, e.t2);
		int mx = max(e.t1, e.t2);
		int w = e.w;
		if (mn + w <= mx) {
			e.type = 1;
			e.all = mn + w;
			if (e.all == tp[v])
				cnt[v]++;
		}
		else {
			e.type = 2;
			e.all = (mx - mn) + (w - (mx - mn) + 1) / 2;
			line.push_back(make_pair(e.all, 0));
		}
		if (to != p)
			dfs(to, v);
	}
}

int main() {
	cin >> n;
	for (int i = 1; i < n; i++) {
		int fr, to, w;
		cin >> fr >> to >> w;
		gr[fr].push_back({ to, w });
		gr[to].push_back({ fr, w });
	}
	int m; cin >> m;
	fill(tp, tp + n, INF);
	for (int i = 0; i < m; i++) {
		int x; cin >> x;
		tp[x] = 0;
	}
	min_path();
	dfs(1);
	sort(line.begin(), line.end());
	int ans = 1;
	for (int i = 1; i <= n; i++) {
		if (tp[i] == 0)
			ans += ed[i] - 1;
	}
	int res = ans;
	for (int i = 0; i < (int)line.size(); i++) {
		if (line[i].first == 0)
			continue;
		if (line[i].second != 0) {
			int v = line[i].second;
			res += ed[v] - cnt[v] - 1;
		}
		else
			res--;
		ans = max(res, ans);
	}
	cout << ans;
}

/*
8
1 2 1
1 3 1
2 4 1
2 5 1
3 6 1
3 7 1
1 8 4
2
1 8
*/