#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <math.h>
#include <map>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)

const ll p = (ll)1e+6 + 3ll;
const ll mod = (ll)1e+9 + 7ll;

ll get_hash(string s)
{
	ll res = 0ll;
	forn(i, (int)s.size())
		res = (res * p + (ll)s[i]) % mod;
	return res;
}

int stringtoint(string s)
{
	int sign, ptr;
	if (s[0] == '-')
	{
		sign = -1;
		ptr = 1;
	}
	else
	{
		sign = 1;
		ptr = 0;
	}
	int res = 0;
	int r = 1;
	for (int i = (int)s.size() - 1; i >= ptr; i--, r *= 10)
		res += (int)(s[i] - '0') * r;
	return res * sign;
}

unordered_map<string, ll> hh;
vector <string> arr;

int i = 0;
void rec(map <ll, int> now)
{
	string s;
	while (true)
	{
		if (i >= (int)arr.size())
			exit(0);
		s = arr[i];
		if (s == "{")
		{
			i++;
			rec(now);
			continue;
		}
		if (s == "}")
		{
			i++;
			return;
		}
		int eq = s.find("=");
		int len1 = eq, len2 = (int)s.size() - eq;
		string a = s.substr(0, len1);
		string b = s.substr(eq + 1, len2);
		if (hh.count(b) == 1)
		{
			now[hh[a]] = now[hh[b]];
			cout << now[hh[a]] << endl;
		}
		else
			now[hh[a]] = stringtoint(b);
		i++;
	}
}

int main()
{
	//freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	string s;
	while (cin >> s)
	{
		arr.push_back(s);
		if (s == "}" || s == "{")
			continue;
		int eq = s.find("=");
		int len1 = eq, len2 = (int)s.size() - eq;
		string a = s.substr(0, len1);
		string b = s.substr(eq + 1, len2);
		if ('a' <= a[0] && a[0] <= 'z')
			hh[a] = get_hash(a);
		if ('a' <= b[0] && b[0] <= 'z')
			hh[b] = get_hash(b);
	}

	rec({});

	return 0;
}