#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <sstream>
#include <map>
#include <stack>
#include <set>

using namespace std;

const long long INF = 1e15;

struct edge {
    int a, b;
    long long l, t;
};

/*
8
1 2 1
1 3 1
2 4 1
2 5 1
3 6 1
3 7 1
1 8 4
2
1 8
*/

int main() {
    int n;
    cin >> n;
    vector<vector<pair<int, long long>>> g(n);
    vector<edge> edges(n - 1);
    for(int i = 0; i < n - 1; i++) {
        edge a;
        cin >> a.a >> a.b >> a.l;
        a.a--;
        a.b--;
        g[a.a].push_back(make_pair(a.b, a.l));
        g[a.b].push_back(make_pair(a.a, a.l));
        edges[i] = a;
    }

    vector<long long> dist(n, INF);
    vector<int> prev(n, -1);
    set<pair<long long, int>> s;
    int m;
    cin >> m;
    for(int i = 0; i < m; i++) {
        int a;
        cin >> a;
        dist[a - 1] = 0;
        s.insert(make_pair(0, a - 1));
        prev[a - 1] = a - 1;
    }

    while(!s.empty()) {
        auto v = *s.begin();
        s.erase(*s.begin());
        for(auto u : g[v.second]) {
            if(dist[u.first] > dist[v.second] + u.second) {
                s.erase(make_pair(dist[u.first], u.first));
               dist[u.first] = dist[v.second] + u.second;
                prev[u.first] = v.second;
               s.insert(make_pair(dist[u.first], u.first));
            }
        }
    }

    vector<pair<long double, int>> times;
    for(int i = 0; i < n - 1; i++) {
        times.push_back(make_pair(max(dist[edges[i].a], dist[edges[i].b]), i + 1));
        //times.push_back(make_pair(dist[edges[i].b], i + 1));
        if(prev[edges[i].a] != prev[edges[i].b]) {
            long long d = abs(dist[edges[i].a] - dist[edges[i].b]);
            times.push_back(make_pair(d + (edges[i].l - d) / 2.0, -(i + 1)));
        }
    }

    sort(times.begin(), times.end());
    reverse(times.begin(), times.end());

    int ma = 0;
    int comp = 0;
    vector<int> used(n - 1, 0);
    vector<bool> u(n, 0);

    for(int i = 0; i < n; i++)
        if(dist[i] == 0)
            u[i] = true;

    for(int i = 0; i < times.size(); i++) {

        //cout << i << endl;
        if(times[i].second < 0) {
            comp++;
            used[-times[i].second - 1] = -1;
        }
        else {
            if(dist[edges[times[i].second - 1].a] == 0 && !u[edges[times[i].second - 1].b])
                comp++;
            if(dist[edges[times[i].second - 1].b] == 0 && !u[edges[times[i].second - 1].a])
                comp++;
            if(!u[edges[times[i].second - 1].a] && !u[edges[times[i].second - 1].b]) {
                if(used[i] == 0)
                    comp++;
            }
            if(u[edges[times[i].second - 1].a] && u[edges[times[i].second - 1].b]) {
                comp--;
            }

            //if(used[i] == -1 && (dist[edges[times[i].second - 1].a] == 0 || dist[edges[times[i].second - 1].b] == 0))

            if(dist[edges[times[i].second - 1].a] != 0)
                u[edges[times[i].second - 1].a] = true;
            if(dist[edges[times[i].second - 1].b] != 0)
                u[edges[times[i].second - 1].b] = true;
        }
        if(comp > ma)
            ma = comp;
        //cout << times[i].first << ' ' << times[i].second << ' ' << comp << endl;
    }

    cout << ma << endl;

    return 0;
}
