import java.util.*;

public class A {

	public static class Pair implements Comparable<Pair> {
		int n;
		long r;
		
		public Pair(int n, long r) {
			this.n = n;
			this.r = r;
		}

		@Override
		public int compareTo(Pair o) {
			if (r - o.r > 0) {
				return 1;
			} else if (r == o.r) {
				return 0;
			} else {
				return -1;
			}
		}
		
	}
	
	public static class Point implements Comparable<Point> {
		Pair p[] = new Pair[3];
		long d;
		int number;
		long x;
		
		public Point(long x, int number) {
			p[0] = new Pair(0, Math.abs(x - a));
			p[1] = new Pair(1, Math.abs(x - b));
			p[2] = new Pair(2, Math.abs(x - c));
			this.number = number;
			this.x = x;
			update();
		}
		
		public void update() {
			Arrays.sort(p);
			d = p[1].r - p[0].r;
		}

		@Override
		public int compareTo(Point o) {
			if (d - o.d > 0) {
				return 1;
			} else if (d == o.d) {
				return this.number - o.number;
			} else {
				return -1;
			}
		}
	}
	
	static long a;
	static long b;
	static long c;
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		long ans = 0L;
		int[] n = new int[3];
		a = in.nextLong();
		n[0] = in.nextInt();
		b = in.nextLong();
		n[1] = in.nextInt();
		c = in.nextLong();
		n[2] = in.nextInt();
		int y = in.nextInt();
		TreeSet<Point> x = new TreeSet<>();
		for (int i = 0; i < y; i++) {
			x.add(new Point(in.nextLong(), i));
		}
		while (n[0] > 0 && n[1] > 0 && n[2] > 0 && !x.isEmpty()) {
			Point p = x.last();
			x.remove(x.last());
			ans += p.p[0].r;
			n[p.p[0].n]--;
		}
		TreeSet<Point> x1 = new TreeSet<>();
		if (n[0] == 0) {
			for (Point p : x) {
				for (int i = 0; i < n.length; i++) {
					if (p.p[i].n == 0) {
						p.p[i].r = Integer.MAX_VALUE;
					}
				}
				p.update();
				x1.add(p);
			}
			while (n[1] > 0 && n[2] > 0 && !x1.isEmpty()) {
				Point p = x1.last();
				x1.remove(x1.last());
				ans += p.p[0].r;
				n[p.p[0].n]--;
			}
		} else if (n[1] == 0) {
			for (Point p : x) {
				for (int i = 0; i < n.length; i++) {
					if (p.p[i].n == 1) {
						p.p[i].r = Integer.MAX_VALUE;
					}
				}
				p.update();
				x1.add(p);
			}
			while (n[0] > 0 && n[2] > 0 && !x1.isEmpty()) {
				Point p = x1.last();
				x1.remove(x1.last());
				ans += p.p[0].r;
				n[p.p[0].n]--;
			}
		} else {
			for (Point p : x) {
				for (int i = 0; i < n.length; i++) {
					if (p.p[i].n == 2) {
						p.p[i].r = Integer.MAX_VALUE;
					}
				}
				p.update();
				x1.add(p);
			}
			while (n[1] > 0 && n[0] > 0 && !x1.isEmpty()) {
				Point p = x1.last();
				x1.remove(x1.last());
				ans += p.p[0].r;
				n[p.p[0].n]--;
			}
		}
		if (n[0] != 0) {
			for (Point p : x1) {
				ans += Math.abs(p.x - a);
			}
		} else if (n[1] != 0) {
			for (Point p : x1) {
				ans += Math.abs(p.x - b);
			}
		} else {
			for (Point p : x1) {
				ans += Math.abs(p.x - c);
			}
		}
		System.out.println(ans);
		in.close();
	}

}
