import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class B {

	public static class Edge {
		int x;
		int y;
		long l;
		int number;

		public Edge(int x, int y, long l, int number) {
			this.x = x;
			this.y = y;
			this.l = l;
			this.number = number;
		}
	}

	public static class X implements Comparable<X> {
		long t;
		int type;
		int n;
		int edge;
		int number;

		public X(long t, int type, int n, int edge, int number) {
			super();
			this.t = t;
			this.type = type;
			this.n = n;
			this.edge = edge;
			this.number = number;
		}

		@Override
		public int compareTo(X o) {
			// TODO Auto-generated method stub
			if (this.t > o.t) {
				return 1;
			} else if (this.t < o.t) {
				return -1;
			}
			return this.type - o.type;
		}

	}

	public void solve() throws IOException {
		int n = nextInt();
		ArrayList<Edge>[] to = new ArrayList[n];
		for (int i = 0; i < to.length; i++) {
			to[i] = new ArrayList<>();
		}
		for (int i = 0; i < n - 1; i++) {
			int x = nextInt() - 1;
			int y = nextInt() - 1;
			long l = nextLong() * 2;
			to[x].add(new Edge(x, y, l, i));
			to[y].add(new Edge(y, x, l, i));
		}
		boolean[] edge = new boolean[n - 1];
		long[] z = new long[n];
		for (int i = 0; i < z.length; i++) {
			z[i] = -1;
		}
		int m = nextInt();
		int th = m + 1;
		int ans = 0;
		int number = 0;
		TreeSet<X> set = new TreeSet<>();
		int[] q = new int[m];
		for (int i = 0; i < q.length; i++) {
			q[i] = nextInt();
			set.add(new X(0, 0, q[i], -1, number));
			number++;
		}
		while (!set.isEmpty()) {
			long time = set.first().t;
			while (!set.isEmpty() && set.first().t == time) {
				X y = set.first();
				set.remove(set.first());
				if (y.type == 1) {
					edge[y.edge] = true;
					th--;
				} else {
					if (z[y.n] == -1) {
						z[y.n] = time;
						th += to[y.n].size() - 2;
						for (Edge e : to[y.n]) {
							if (!edge[e.number]) {
								if (z[e.y] == -1) {
									set.add(new X(time + e.l, 0, e.y, e.number, number));
									number++;
								} else {
									set.add(new X(time + (e.l - (time - z[e.y]) / 2), 
											1, -1, e.number, number));
									number++;
								}
							}
						}
					}
				}
			}
			ans = Math.max(ans, th);
		}
		System.out.println(ans);
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new B().run();
	}

}
