#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <iterator>
using namespace std;
#define rep(i, n) for (int i = 0; i < n; i++)
#define repp(i, a, b) for (int i = a; i < b; i++)
#define sz(s) (int)s.size()
#define all(v) v.begin(), v.end()

void dfs(int s, vector<int> &ord, vector<bool> &was, vector<vector<int>> &g) {
	was[s] = true;
	for (int to : g[s]) {
		if (!was[to]) dfs(to, ord, was, g);
	}
	ord.push_back(s);
}

int dfs2(int s, int c, vector<int> &color, vector<vector<int>> &g) {
	color[s] = c;
	int ans = 1;
	for (int to : g[s]) {
		if (color[to]) continue;
		ans += dfs2(to, c, color, g);
	}
	return ans;
}

void print(int a, int n, vector<int> &cur) {
	if (a >= n) {
		cout << a - n + 1 << " " << 0 << endl;
		cur[a - n] = 0;
	}
	else {
		cout << a + 1 << " " << 1 << endl;
		cur[a] = 1;
	}
}

void cont(vector<int> &cur) {
	int n = sz(cur);
	int now = 0;
	while (now < cur.size() && cur[now] != -1) now++;
	while (now != cur.size()) {
		print(now, n, cur);
		int a, b;
		cin >> a >> b;
		a--;
		cur[a] = b;
		while (now < cur.size() && cur[now] != -1) now++;
	}
}

int inv(int a, int n) {
	if (a >= n) return a - n;
	else return a + n;
}

bool endcheck(vector<int> &cur) {
	rep(i, sz(cur)) if (cur[i] == -1) return 0;
	return true;
}
int main() {
	ios_base::sync_with_stdio(0);
	int n, m;
	cin >> n >> m;
	vector<vector<int>> g(2 * n);
	rep(i, m) {
		int a, b;
		cin >> a >> b;
		int ap, bp, am, bm;
		if (a > 0) ap = a - 1;
		else ap = -a - 1;
		am = ap + n;
		if (b > 0) bp = b - 1;
		else bp = -b - 1;
		bm = bp + n;
		if (a > 0 && b > 0) {
			g[am].push_back(bp);
			g[bm].push_back(ap);
		}
		if (a < 0 && b < 0) {
			g[ap].push_back(bm);
			g[bp].push_back(am);
		}
		if (a > 0 && b < 0) {
			g[am].push_back(bm);
			g[bp].push_back(ap);
		}
		if (a < 0 && b > 0) {
			g[ap].push_back(bp);
			g[bm].push_back(am);
		}
	}
	vector<int> in(2 * n);
	rep(i, 2 * n) {
		for (int to : g[i]) {
			in[to]++;
		}
	}
	vector<int> ord;
	vector<bool> was(2 * n);
	int t = 1;
	rep(i, 2 * n) if (!was[i]) dfs(i, ord, was, g);
	reverse(all(ord));
	vector<int> color(2 * n);
	int c = 1;
	rep(i, sz(ord)) {
		if (!color[i]) dfs2(i, c++, color, g);
	}
	vector<int> vsz(c);
	rep(i, 2 * n) vsz[color[i]]++;
	int win = -1;
	rep(i, c) if (vsz[i] > 2) win = i;
	vector<int> cur(n, -1);
	if (win != -1) {
		vector<int> q;
		rep(i, n) if (color[i] == win && q.size() < 3) q.push_back(i);
		print(q.back(), n, cur);
		q.pop_back();
		int a, b;
		cin >> a >> b;
		a--;
		cur[a] = b;
		if (cur[q.back()] != -1) q.pop_back();
		print(q.back(), n, cur);
		if (endcheck(cur)) return 0;
		cin >> a >> b;
		a--;
		cur[a] = b;
		cont(cur);
	}
	else {
		int free = 0;
		vector<int> f;
		vector<bool> isf(n);
		vector<int> ver(c);
		rep(i, 2 * n) ver[color[i]] = i;
		rep(i, c) if (vsz[i] == 1) {
			if (ver[i] < n) {
				free++;
				f.push_back(ver[i]);
				isf[ver[i]] = true;
			}
		}
		int cyc = 0;
		rep(i, 2 * n) {
			if (g[i].size() == 1 && in[i] == 1) cyc++;
			if (in[i] == 0 && i < n) isf[i] = true;
		}
		if (cyc == 0 || free % 2 == 0) {
			cout << "-1 -1";
			return 0;
		}
		else {
			rep(i, sz(f)) {
				if (cur[f[i]] != -1) continue;
				print(f[i], n, cur);
				if (endcheck(cur)) return 0;
				int a, b;
				cin >> a >> b;
				a--;
				cur[a] = b;
				if (!isf[a]) {
					if (b == 0) a += n;
					print(inv(g[a][0], n), n, cur);
					if (endcheck(cur)) return 0;
					int c, d;
					cin >> c >> d;
					c--;
					cur[c] = d;
					cont(cur);
					return 0;
				}
			}
			cont(cur);
		}
	}
}