// A.cpp : Defines the entry poll for the console application.
//

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <algorithm>
#include <stack>

using namespace std;

typedef long long ll;
typedef long double ld;
const double EPS = 1e-9;
const long long MOD = 1e9 + 7;

vector<vector<pair<ll, ll> > > g;
vector<vector<ll> > gk;
const ll MSIZE = 4e5;
vector<ll> start;
ll n;
vector<pair<long long, ll> > dp;

vector<long long > dpk;

ll parent[MSIZE];
ll cnt[MSIZE];
const ll INF = 1e16;

void init() {
	for (ll i = 0; i < MSIZE; ++i) {
		cnt[i] = 1;
		parent[i] = i;
	}
}

ll get(ll a) {
	return parent[a] == a ? a : parent[a] = get(parent[a]);
}

void union_s(ll a, ll b) {
	a = get(a), b = get(b);
	if (a != b) {
		if (cnt[a] > cnt[b])
			swap(a, b);
		cnt[b] += cnt[a];
		parent[a] = b;
	}
}

void dfs(ll v, ll p = -1) {
	dpk[v] = 2 * dp[v].first;
	for (auto to : g[v]) {
		if (to.first == p)
			continue;
		if (dp[to.first].second != dp[v].second) {
			gk[v].push_back(n);
			gk[to.first].push_back(n);
			gk[n].push_back(to.first);
			gk[n].push_back(v);
			dpk[n++] = abs(dp[v].first - dp[to.first].first) * 2 + (to.second - abs(dp[v].first - dp[to.first].first));
		}
		else {
			gk[v].push_back(to.first);
			gk[to.first].push_back(v);
		}
		dfs(to.first, v);
	}
}

void dijkstr() {
	dp.resize(n, {INF, INF});
	set<pair<long long, ll> > v;
	for (ll a : start)
		v.insert({ (ll)0, a }), dp[a] = { 0, a };
	while (!v.empty()) {
		pair<long long, ll> cur = *v.begin();
		v.erase(v.begin());
		for (auto to : g[cur.second]) {
			if (dp[to.first].first > dp[cur.first].first + to.second) {
				v.erase(make_pair(dp[to.first].first, to.first));
				dp[to.first] = { dp[cur.first].first + to.second, dp[cur.first].second };
				v.insert(make_pair(dp[to.first].first, to.first));
			}
		}
	}
	gk.resize(2 * n);
	dpk.resize(2 * n);
	dfs(0);
	vector<pair<long long, ll> > hist;
	for (ll i = 0; i < n; ++i)
		hist.push_back({ dpk[i], i });
	sort(hist.rbegin(), hist.rend());
	vector<ll> fr(n, 0);
	ll cur = 0, res = 0;
	for (ll i = 0; i < hist.size(); ++i) {
		cur++;
		fr[hist[i].second] = 1;
		for (ll to : gk[hist[i].second]) {
			if (fr[to]) {
				cur--;
				union_s(to, hist[i].second);
			}
		}
		if (i == hist.size() - 1 || hist[i + 1].first != hist[i].first)
			res = max(res, cur);
	}
	cout << res;
}


int main() {
	ios_base::sync_with_stdio(0);
	/*freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);*/
	cin >> n;
	init();
	g.resize(n);
	for (ll i = 0; i < n - 1; ++i) {
		ll a, b;
		long long d;
		cin >> a >> b >> d;
		a--, b--;
		g[a].push_back({ b, d });
		g[b].push_back({ a, d });
	}
	ll m;
	cin >> m;
	start.resize(m);
	for (ll i = 0; i < m; ++i) {
		cin >> start[i];
		start[i]--;
	}
	dijkstr();
	return 0;
}