#include <bits/stdc++.h>
using namespace std;

using lint = int64_t;

const lint inf = lint(1e18);
const int MAX = 2010;

int d[MAX];
int c[MAX];
int p[MAX];
int all_d[MAX];

struct fenv {
    lint a[MAX];

    fenv() {
        fill(a, a + MAX, inf);
    }

    lint get(int r) {
        lint res = inf;
        for (; r >= 0; r = (r & (r + 1)) - 1) {
            res = min(res, a[r]);
        }
        return res;
    }

    void upd(int i, lint x) {
        for (; i < MAX; i |= i + 1) {
            a[i] = min(a[i], x);
        }
    }
};

fenv dp[MAX];
lint d_price[MAX][MAX];
int prev_j[MAX][MAX];

int main(int argc, char** argv) {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        cin >> d[i] >> c[i] >> p[i];
        d[i] *= -1;
        all_d[i] = d[i];
    }
    d[0] = -int(2e9);
    all_d[0] = d[0];

    sort(all_d, all_d + n + 1);
    auto unique_d = unique(all_d, all_d + n + 1) - all_d;
    for (int i = 0; i <= n; i++) {
        d[i] = lower_bound(all_d, all_d + unique_d, d[i]) - all_d;
    }

    dp[0].upd(0, 0);
    fill(d_price[0], d_price[0] + MAX, inf);
    d_price[0][0] = 0;

    for (int i = 1; i <= n; i++) {
        fill(d_price[i], d_price[i] + MAX, inf);
        for (int j = m - 1; j >= 0; j--) {
            int cj = min(m, j + c[i]);
            lint min_c = dp[j].get(d[i]);
            if (min_c == inf) {
                continue;
            }
            if (d_price[i][cj] > min_c + p[i]) {
                dp[cj].upd(d[i], min_c + p[i]);
                d_price[i][cj] = min_c + p[i];
                prev_j[i][cj] = j;
            }
        }
    }

    int lst = n;
    for (int i = 0; i < n; i++) {
        if (d_price[i][m] < d_price[lst][m]) {
            lst = i;
        }
    }

    if (d_price[lst][m] == inf) {
        cout << -1;
        return 0;
    }
    lint s_price = d_price[lst][m];
    lint c_price = s_price;

    vector<int> ans;
    for (int i = lst - 1; i >= 0; i--) {
        if (d[i] > d[lst]) {
            continue;
        }
        if (d_price[i][prev_j[lst][m]] + p[lst] == c_price) {
            ans.push_back(lst);
            c_price -= p[lst];
            m = prev_j[lst][m];
            lst = i;
        }
    }

    reverse(ans.begin(), ans.end());
    cout << s_price << " " << ans.size() << "\n";
    for (int i : ans) {
        cout << i << " ";
    }
    cout << "\n";


    return 0;
}